KERNEL_PATH=$1

echo Generating simulator from $KERNEL_PATH

if [ ! -f $KERNEL_PATH/Makefile ]; then
	echo "$KERNEL_PATH doesn't look like the kernel source"
	exit 1
fi

#simple stuff first
cp $KERNEL_PATH/kernel/timeofday.c ./
cp $KERNEL_PATH/include/asm-generic/timeofday.h ./asm/
cp $KERNEL_PATH/include/linux/timeofday.h ./linux/
cp $KERNEL_PATH/include/linux/clocksource.h ./linux/


#generate the ntp portions
NTPFILE=sim-ntp.c

#first cut out a few full functions
echo '#include "sim.h"' > $NTPFILE
sed --silent -e '/void ntp_clear/,/^}/p' < ../timeofday-all/include/linux/timex.h >> $NTPFILE
sed --silent -e '/int ntp_synced/,/^}/p' < ../timeofday-all/include/linux/timex.h >> $NTPFILE

sed --silent -e '/int ntp_leapsecond/,/^}/p' < ../timeofday-all/kernel/timer.c >> $NTPFILE
sed --silent -e '/static void second_overflow/,/^}/p' < ../timeofday-all/kernel/timer.c >> $NTPFILE
sed --silent -e '/void ntp_advance/,/^}/p' < ../timeofday-all/kernel/timer.c >> $NTPFILE
sed --silent -e '/long ntp_get_ppm_adjustment/,/^}/p' < ../timeofday-all/kernel/timer.c >> $NTPFILE

#now the really ugly bits
echo "void adjtimex_hardupdate(long offset, struct timespec now_ts)" >>$NTPFILE
echo "{" >>$NTPFILE
echo "	long ltemp, mtemp;" >>$NTPFILE
echo "	int result;" >>$NTPFILE

sed --silent -e '/else if ( time_status & (STA_PLL | STA_PPSTIME) )/,/STA_PLL || STA_PPSTIME/p' < ../timeofday-all/kernel/time.c >> $NTPFILE

echo "}" >>$NTPFILE

#apply a quick diff
patch -p1 < fixup.patch

