typedef unsigned long long u64;
typedef unsigned long u32;

typedef u64 nsec_t;
typedef u32 cycle_t;

struct timespec {
	u32 tv_sec;
	u32 tv_nsec;
};
struct timeval {
	u32 tv_sec;
	u32 tv_usec;
};

#define CONFIG_GENERICTOD

#define NSEC_PER_SEC 1000000000
#define USEC_PER_SEC 1000000
#define NSEC_PER_USEC 1000

#define mod_timer(x,y)
#define jiffies 0
#define msec_to_jiffies(x) 0
#define KERN_INFO

struct timerlist {
	int x;
};

typedef u32 seqlock_t;
#define SEQLOCK_UNLOCKED 0
#define write_seqlock_irqsave(x,y)
#define write_sequnlock_irqrestore(x,y)
#define read_seqbegin(x) 0
#define read_seqretry(x,y) 0

#define __init

extern struct timespec xtime;
extern struct timespec wall_to_monotonic;


#define BUG_ON(x)
struct sys_device{
	int id;
	void* cls;
};
struct sysdev_class {
	void* resume;
	void* suspend;
	int i;
};
#define set_kset_name(x) 0
#define pm_message_t int
#define device_initcall(x) 
#define __iomem

struct list_head {
};

#define SHIFT_USEC 16
#define EXPORT_SYMBOL(x)

#define inline

struct timer_list{
	void* function;
	int expires;
};
#define init_timer(x)
#define add_timer(x)

#define do_div(n,base) ({ \
	unsigned long __upper, __low, __high, __mod, __base; \
	__base = (base); \
	asm("":"=a" (__low), "=d" (__high):"A" (n)); \
	__upper = __high; \
	if (__high) { \
		__upper = __high % (__base); \
		__high = __high / (__base); \
	} \
	asm("divl %2":"=a" (__low), "=d" (__mod):"rm" (__base), "0" (__low), "1" (__upper)); \
	asm("":"=A" (n):"a" (__low),"d" (__high)); \
	__mod; \
})

#define readl(x) 0
#define get_cycles() 0
#define clock_was_set()
#define time_t u32

#define printk(x,...) {}

extern void set_normalized_timespec (struct timespec *ts, time_t sec, long nsec);

#define min(x,y) ( x < y ? x : y)
#define max(x,y) (x > y ? x : y)

#define shift_right(x, s) ({	\
	__typeof__(x) __x = (x);	\
	__typeof__(s) __s = (s);	\
	__x < 0 ? -(-__x >> __s) : __x >> __s;	\
})

#define HZ 1000
#define USER_HZ 100
#define CLOCK_TICK_RATE 1193182

#if HZ >= 12 && HZ < 24
# define SHIFT_HZ	4
#elif HZ >= 24 && HZ < 48
# define SHIFT_HZ	5
#elif HZ >= 48 && HZ < 96
# define SHIFT_HZ	6
#elif HZ >= 96 && HZ < 192
# define SHIFT_HZ	7
#elif HZ >= 192 && HZ < 384
# define SHIFT_HZ	8
#elif HZ >= 384 && HZ < 768
# define SHIFT_HZ	9
#elif HZ >= 768 && HZ < 1536
# define SHIFT_HZ	10
#else
# error You lose.
#endif

#define LATCH  ((CLOCK_TICK_RATE + HZ/2) / HZ)

#define SH_DIV(NOM,DEN,LSH) (   ((NOM / DEN) << LSH)                    \
                             + (((NOM % DEN) << LSH) + DEN / 2) / DEN)

#define ACTHZ (SH_DIV (CLOCK_TICK_RATE, LATCH, 8))

#define TICK_NSEC (SH_DIV (1000000UL * 1000, ACTHZ, 8))
#define TICK_USEC ((1000000UL + USER_HZ/2) / USER_HZ)

#define SHIFT_KG 6
#define SHIFT_KF 16
#define SHIFT_KH 2
#define MAXTC 6

#define SHIFT_SCALE 22
#define SHIFT_UPDATE (SHIFT_KG + MAXTC)
#define SHIFT_USEC 16
#define FINENSEC (1L << (SHIFT_SCALE - 10))

#define MAXPHASE 512000L
#define MAXFREQ (512L << SHIFT_USEC)
#define MAXTIME (200L << PPS_AVG)
#define MINSEC 16L
#define MAXSEC 1200L
#define	NTP_PHASE_LIMIT	(MAXPHASE << 5)

#define PPS_AVG 2
#define PPS_SHIFT 2
#define PPS_SHIFTMAX 8
#define PPS_VALID 120
#define MAXGLITCH 30


#define STA_PLL      0x0001
#define STA_PPSFREQ  0x0002
#define STA_PPSTIME  0x0004
#define STA_FLL      0x0008

#define STA_INS      0x0010
#define STA_DEL      0x0020
#define STA_UNSYNC   0x0040
#define STA_FREQHOLD 0x0080

#define STA_PPSSIGNAL 0x0100
#define STA_PPSJITTER 0x0200
#define STA_PPSWANDER 0x0400
#define STA_PPSERROR  0x0800


#define TIME_OK    0
#define TIME_INS   1
#define TIME_DEL   2
#define TIME_OOP   3
#define TIME_WAIT  4
#define TIME_ERROR 5



extern long pps_offset;
extern long pps_jitter;
extern long pps_freq;
extern long pps_stabil;
extern long pps_valid;
extern unsigned long tick_usec;
extern unsigned long tick_nsec;
extern int tickadj;
extern int time_state;
extern int time_status;
extern long time_offset;
extern long time_constant;
extern long time_tolerance;
extern long time_precision;
extern long time_maxerror;
extern long time_esterror;
extern long time_freq;
extern long time_adj;
extern long time_reftime;
extern long time_adjust;
extern long time_next_adjust;
extern long time_adjust_step;
extern long total_sppm;
extern long offset_adj_ppm;
extern long tick_adj_ppm;
extern long singleshot_adj_ppm;

#define MAX_SINGLESHOT_ADJ 500
#define SEC_PER_DAY 86400
#define END_OF_DAY(x) (x + SEC_PER_DAY - (x % SEC_PER_DAY) - 1)
